# -*- coding: utf-8 -*-
#import rpdb2 
#rpdb2.start_embedded_debugger('pw')

import urllib, urllib2
import os, re, sys, md5, string
import xbmc, xbmcgui, xbmcplugin
import datetime
from elementtree.ElementTree import *

media="http://search.yahoo.com/mrss/"
atom="http://www.w3.org/2005/Atom"
opensearch="http://a9.com/-/spec/opensearch/1.1/"


########################################################################################
#####################################    COMMON    #####################################       
########################################################################################

def getURL( url ):
        try:
                print 'ZDFN --> getURL :: url = '+url
                req = urllib2.Request(url)
                req.addheaders = [('Referer', 'http://www.zdf.de'),
                                  ('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.7) Gecko/2009021910 Firefox/3.0.7)')]
                response = urllib2.urlopen(req)
                link=response.read()
                response.close()
        except urllib2.URLError, e:
                error = 'Error code: '+ str(e.code)
                xbmcgui.Dialog().ok(error,error)
                print 'Error code: ', e.code
                return False
        else:
                return link

def parseapiVideos(response):
        if response == False:
                return False
                print 'error in parseapiVideos'
        tree1 = ElementTree(fromstring(response))
        videos = []
        for entry in tree1.getroot().findall('.//teaser'):
                if entry.find('.//type').text != 'video':
                        continue
                video = []
                video.append(entry.find('.//assetId').text)
                video.append(entry.find('.//title').text)
                thumbnailimage = entry.find('.//teaserimage').text
                for t in entry.findall('.//teaserimage'): #Parsing thumbnails for good size
                         pict = t.text
                         if 'timg485x273' in pict:
                                 thumbnailimage = pict+'.gif'
                                 break
                         elif 'timg276x155' in pict: #fallback thumbnail
                                 thumbnailimage = pict+'.gif'
                                 break
                video.append(thumbnailimage)
                plot = ''
                datum = ''
                length = ''
                genre = ''
                plot = entry.find('.//detail').text
                datum = entry.find('.//airtime').text
                length = entry.find('.//length').text
                genre = entry.find('.//originChannelTitle').text
                if len(plot) == 0:
                        plot = 'NA'
                if len(datum) == 0:
                        datum = '01.01.1979 22:45'
                if len(length) == 0:
                        length = '00:01:00.000'
                if len(genre) == 0:
                        genre = 'NA'
                video.append(plot)
                video.append(datum)
                video.append(length)
                video.append(genre)
                videos.append(video)            
        return videos

def parseapiArtists(response):
        if response == False:
                return False
                print 'error in parseapi'
        tree1 = ElementTree(fromstring(response))
        artists = []
        for entry in tree1.getroot().findall('.//teaser'):
                artist = []
                artist.append(entry.find('.//assetId').text)
                artist.append(entry.find('.//title').text)
                thumbnailimage = entry.find('.//teaserimage').text
                for t in entry.findall('.//teaserimage'):
                         pict = t.text
                         if 'timg485x273' in pict:
                                 thumbnailimage = pict+'.gif'
                                 break
                         elif 'timg173x120' in pict:
                                 thumbnailimage = pict+'.gif'
                                 break
                artist.append(thumbnailimage)
                artist.append(entry.find('.//length').text)
                artists.append(artist)
        return artists

########################################################################################
#####################################     VIDEO     ####################################       
########################################################################################


#Requires parameters term ?term=
#Returns a list of videos for a specific search term.
def videoSearch(term):
        VideoSearch = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/detailsSuche?maxLength=20'
        term = '"'+term+'"'
        encode = urllib.quote_plus(term)
        url = VideoSearch +'&searchString='+ encode
        response = getURL(url)
        return parseapiVideos(response)

#Returns videos associated to a specific artist.
def artistVideos(artist):
        ArtistVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/aktuellste?maxLength=25&id=[artist_uri]'
        url = ArtistVideos.replace('[artist_uri]',artist)
        print 'ZDFN --> artistVideos :: url = '+url
        response = getURL(url)
        return parseapiVideos(response)
        
        
def artistVideos2(genre,maxitems,startindex):
        GenreVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/aktuellste?id=[genre_alias]'
        url = GenreVideos.replace('[genre_alias]',genre) + "&maxLength=" + str(maxitems) + "&offset=" + str(startindex)
        response = getURL(url)
        return parseapiVideos(response)
        
def artistVideosFull(genre,maxitems,startindex):
        GenreVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/aktuellste?id=[genre_alias]'
        url = GenreVideos.replace('[genre_alias]',genre) + "&maxLength=" + str(maxitems) + "&offset=" + str(startindex) + "&ganzeSendungen=true"
        response = getURL(url)
        return parseapiVideos(response)
        
def topVideos(genre,maxitems,startindex):
        GenreVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/meistGesehen?id=_GLOBAL'
        url = GenreVideos + "&maxLength=" + str(maxitems) + "&offset=" + str(startindex)
        response = getURL(url)
        return parseapiVideos(response)
        
def tippsVideos(genre,maxitems,startindex):
        GenreVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/tipps?id=_STARTSEITE'
        url = GenreVideos + "&maxLength=" + str(maxitems) + "&offset=" + str(startindex)
        response = getURL(url)
        return parseapiVideos(response)
        
def newsVideos(genre,maxitems,startindex):
        GenreVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/aktuellste?id=_NACHRICHTEN'
        url = GenreVideos + "&maxLength=" + str(maxitems) + "&offset=" + str(startindex)
        response = getURL(url)
        return parseapiVideos(response)
        
def missedVideos(genre,maxitems,startindex):
        GenreVideos = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/sendungVerpasst?startdate=[start_date]&enddate=[end_date]'
        today = datetime.date.today()
        if genre == 'today':
                startdate = today.strftime("%d%m%y")
        else:
                yesterday = datetime.timedelta(days=-1)
                yesterday = today + yesterday
                startdate = yesterday.strftime("%d%m%y")
        url = GenreVideos.replace('[end_date]',startdate)
        url = url.replace('[start_date]',startdate) + "&maxLength=" + str(maxitems) + "&offset=" + str(startindex)
        response = getURL(url)
        return parseapiVideos(response)


########################################################################################
#####################################     ARTIST    ####################################       
########################################################################################





# List all Shows Alphabetically
def artistBrowse(letter):
        RangeSt = letter.split('-')[0]
        RangeEn = letter.split('-')[1]
        ArtistBrowse = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/sendungenAbisZ?detailLevel=2&characterRangeStart=[alpha]&characterRangeEnd=[beta]'
        url = ArtistBrowse.replace('[alpha]',RangeSt)
        url = url.replace('[beta]',RangeEn)
        response = getURL(url)
        return parseapiArtists(response)
        
def rubrikenBrowseDetail(letter):
        ArtistBrowse = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/aktuellste?maxLength=25&ak=web&offset=0&id=[alpha]&ganzeSendungen=false'
        url = ArtistBrowse.replace('[alpha]',letter)
        response = getURL(url)
        return parseapiArtists(response)
        
def rubrikenBrowse(letter):
        ArtistBrowse = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/rubriken'
        response = getURL(ArtistBrowse)
        return parseapiArtists(response)
        
def themenBrowse(letter):
        ArtistBrowse = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/themen'
        response = getURL(ArtistBrowse)
        return parseapiArtists(response)

# bersicht Nachrichten Ganze Sendung
def relatedArtists(artist):
        RelatedArtist = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/ganzeSendungen'
        url = RelatedArtist
        response = getURL(url)
        return parseapiArtists(response)

########################################################################################
####################################      Videolink parsing and RTMP thingy      ####################################       
########################################################################################

# Here we extract the rtmp-url from the zdf smil file (needed for h264 videos)
def getrtmp(uri, qualit):
        smilmeta = getURL(uri)
        if smilmeta == False:
                return False
        if qualit == '600':
                bitr = '_h.mp4'
        else:
                bitr = '_vh.mp4'
        urls = re.compile('src="(.+?)"').findall(smilmeta)
        rtmp = []
        for rtmpurl in urls:
                if bitr in rtmpurl:
                        rtmpurl =rtmpurl.replace('rtmpe','rtmp')
                        rtmpurl = rtmpurl.replace('rtmp://','')
                        rtmpsplit = rtmpurl.split('.net/zdf/')
                        rtmphost = rtmpsplit[0]+'.net'
                        playpath = rtmpsplit[1]
                        if '.flv' in playpath:
                                playpath = playpath.replace('.flv','')
                        #elif '.mp4' in playpath:
                                #playpath = 'mp4:'+ playpath.replace('.mp4','')
                                #playpath = playpath.replace('.mp4','')
                        app = 'zdf' 
                        identurl = 'http://'+rtmphost+'/fcs/ident2'
                        ident = getURL(identurl)
                        #ip = re.compile('<fcs><ip>(.+?)</ip></fcs>').findall(ident)[0]
                        ip = ident
                        rtmpuri = 'rtmp://'+ip+'/'+app+'?_fcs_vhost='+rtmphost
                else:                      
                        print rtmpurl
        if len(rtmpuri) != 0:
                rtmp.append(rtmpuri)
                rtmp.append(playpath)
                
        return rtmp
        
        
# Here we parse the videolinks for the streamtype and bitrate we want
def getvideo(uri):
        ArtistVideoLink = 'http://www.zdf.de/ZDFmediathek/xmlservice/web/beitragsDetails?ak=web&id=[artist_uri]'
        smilurl = ArtistVideoLink.replace('[artist_uri]',uri)
        print 'ZDFN --> GetVideo :: url = '+smilurl
        smil = getURL(smilurl)
        if smil == False:
                return False
                print 'error in getvideo'
                
        tree1 = ElementTree(fromstring(smil))
        videolinks = []
        for entry in tree1.getroot().findall('.//formitaet'):
                videolinks.append(entry.find('.//url').text)                   
        rtmps = []
        for rtmpurl in videolinks:
                if '.asx' in rtmpurl: # Theses are wmv streams
                        if '/300/' in rtmpurl:
                                rtmp = []
                                quali = 'wmv600'
                                rtmp.append(rtmpurl)
                                rtmp.append(quali)
                                rtmps.append(rtmp)
                        elif 'veryhigh' in rtmpurl:
                                rtmp = []
                                quali = 'wmv1800'
                                rtmp.append(rtmpurl)
                                rtmp.append(quali)
                                rtmps.append(rtmp)
                elif '.smil' in rtmpurl: # Theses are h264/mp4 streams
                        if '/300/' in rtmpurl:
                                rtmp = []
                                quali = 'mov600'
                                rtmp.append(rtmpurl)
                                rtmp.append(quali)
                                rtmps.append(rtmp)
                        elif 'veryhigh' in rtmpurl:
                                rtmp = []
                                quali = 'mov1800'
                                rtmp.append(rtmpurl)
                                rtmp.append(quali)
                                rtmps.append(rtmp)
#        print 'GETVIDEO RESULTS:'
#        for item in rtmps:
#            for single in item:
#                print single
        return rtmps


